Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic

Imports MSDN.SPTips.Task

Imports Microsoft.VisualStudio.TestTools.UnitTesting

Namespace SPTips.TaskService.Tests
'    
'     * IMPORTANT:
'     * This class contains server dependent tests. 
'     * Provide the appropriate settings through the ITaskRepositoryConfig implementation
'     * that point to the right instance of SharePoint prior to running the tests.
'     * 
'     

	<TestClass> _
	Public Class TaskRepositoryIntegrationTests
		<TestMethod> _
		Public Sub GetTasks_ShouldRetrieveTasksFromRunningInstanceOfSharePoint()
			' use stubbed ITaskRepositoryConfig implementation 
			' to provide configuration settings that the repository requires
			' in an application, you would provide another implementation that pulls the settings
			' out of the configuration file or database
			Dim repConfig As ITaskRepositoryConfig = New StubbedTaskRepositoryConfig()

			Dim repository As ITaskRepository = New SPTaskRepository(repConfig)
			Dim spTasks As List(Of Task) = repository.GetTasks()

			Assert.IsTrue(spTasks.Count > 0, "Expected at least one task")
		End Sub
	End Class
End Namespace
