Imports Microsoft.VisualBasic
Imports System
Imports System.Web.UI.WebControls.WebParts
Imports System.Web.UI.WebControls
Imports System.Security
Imports System.Web.UI
Imports MSDN.SPTips.WebPart.Presentation
Imports MSDN.SPTips.Task

' The AllowPartiallyTrustedCallersAttribute requires the assembly to be signed with a strong name key.
' This attribute is necessary to allow an ASP.NET web part to be imported into SharePoint from the bin
<Assembly: AllowPartiallyTrustedCallers>
Namespace MSDN.SPTips.WebPart
	Public Class WebPartOffServerExample
		Inherits System.Web.UI.WebControls.WebParts.WebPart
		Implements IView
		Private presenter As Presenter

		Private _lblMessage As Label
		Private _gvTasks As GridView

		Public Sub New()
			Me.ExportMode = WebPartExportMode.All
		End Sub

		Protected Overrides Sub OnInit(ByVal e As EventArgs)
			MyBase.OnInit(e)

			' when building this web part to run on the web site
			' in this solution, use this call
			presenter = New Presenter(Me, New StubbedTaskRepository())

			' when deploying this web part to SharePoint and calling
			' a SharePoint task list, use this call
			' presenter = new Presenter(this, new SPTaskRepository());
		End Sub

		Protected Overrides Sub CreateChildControls()
			MyBase.CreateChildControls()

			_lblMessage = New Label()
			Me.Controls.Add(_lblMessage)

			_gvTasks = New GridView()

			' adjust the grid view column display
			' information and styles
			_gvTasks.AutoGenerateColumns = False
			Dim title As New BoundField()
			title.HeaderText = "Task Title"
			title.DataField = "TaskName"
			_gvTasks.Columns.Add(title)

			Dim percentComplete As New BoundField()
			percentComplete.HeaderText = "% Complete"
			percentComplete.DataField = "PercentComplete"
			percentComplete.DataFormatString = "{0:p}"
			_gvTasks.Columns.Add(percentComplete)

			_gvTasks.CellPadding = 2
			_gvTasks.Width = Unit.Percentage(100)
			_gvTasks.BackColor = System.Drawing.Color.Bisque

			_gvTasks.Columns(1).ItemStyle.HorizontalAlign = HorizontalAlign.Center

			Me.Controls.Add(_gvTasks)
		End Sub

		Protected Overrides Sub OnPreRender(ByVal e As EventArgs)
			MyBase.OnPreRender(e)
			' remove the next line if you want to allow
			' the user to set the title at runtime
			Me.Title = "MSDN Web Part for SP Tips article"

			_lblMessage.Text = "Solution Developed Off-Server"

			' this is where we are asking the preseter to go to the repository (model) and retrieve 
			' the data that will then be passed into the view
			presenter.InitializeView()
		End Sub

		' override RenderContents to apply additional conditions/formatting
		' before the control(s) are rendered
		Protected Overrides Sub RenderContents(ByVal writer As HtmlTextWriter)
			EnsureChildControls()

			_lblMessage.RenderControl(writer)
			_gvTasks.RenderControl(writer)
		End Sub

		Public WriteOnly Property Tasks() As TaskCollection Implements IView.Tasks
			Set(ByVal value As TaskCollection)
				EnsureChildControls()

				_gvTasks.DataSource = value
				_gvTasks.DataBind()
			End Set
		End Property


	End Class
End Namespace